// ClassOptions2.cpp : implementation file
//

#include "stdafx.h"
#include "VisualClassBuilder.h"
#include "ClassOptions2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClassOptions2 property page

IMPLEMENT_DYNCREATE(CClassOptions2, CPropertyPage)

CClassOptions2::CClassOptions2() : CPropertyPage(CClassOptions2::IDD)
{
	//{{AFX_DATA_INIT(CClassOptions2)
	m_Name = _T("");
	m_Type = _T("");
	m_Access = 0;
	m_Property = FALSE;
	m_Static = FALSE;
	m_Comment = _T("");
	m_PropertyName = _T("");
	//}}AFX_DATA_INIT

	// Init members
	m_pVariableList = NULL;
	m_iVariableNumber = 0;
}

CClassOptions2::~CClassOptions2()
{
}

void CClassOptions2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClassOptions2)
	DDX_Control(pDX, IDC_LIST_VARIABLES, m_VariablesList);
	DDX_Text(pDX, IDC_EDIT_NAME, m_Name);
	DDV_MaxChars(pDX, m_Name, 256);
	DDX_Text(pDX, IDC_EDIT_TYPE, m_Type);
	DDV_MaxChars(pDX, m_Type, 256);
	DDX_Radio(pDX, IDC_RADIO_ACCESS, m_Access);
	DDX_Check(pDX, IDC_CHECK_PROPERTY, m_Property);
	DDX_Check(pDX, IDC_CHECK_STATIC, m_Static);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_Comment);
	DDV_MaxChars(pDX, m_Comment, 256);
	DDX_Text(pDX, IDC_EDIT_PROPERTY_NAME, m_PropertyName);
	DDV_MaxChars(pDX, m_PropertyName, 256);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClassOptions2, CPropertyPage)
	//{{AFX_MSG_MAP(CClassOptions2)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_UPDATE, OnButtonUpdate)
	ON_NOTIFY(NM_CLICK, IDC_LIST_VARIABLES, OnClickListVariables)
	ON_BN_CLICKED(IDC_CHECK_PROPERTY, OnCheckProperty)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClassOptions2 message handlers

BOOL CClassOptions2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Create variables list control
	m_VariablesList.InsertColumn(0, _T("Type"), LVCFMT_LEFT, 85);
	m_VariablesList.InsertColumn(1, _T("Name"), LVCFMT_LEFT, 110);
	m_VariablesList.InsertColumn(2, _T("Comment"), LVCFMT_LEFT, 60);
	m_VariablesList.InsertColumn(3, _T("Access"), LVCFMT_CENTER, 60);
	m_VariablesList.InsertColumn(4, _T("Property"), LVCFMT_CENTER, 60);
	m_VariablesList.InsertColumn(5, _T("Static"), LVCFMT_CENTER, 60);
	m_VariablesList.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	// Update variable list
	int item;
	for (int i=0; i<m_iVariableNumber; i++)
	{
		item = m_VariablesList.InsertItem(m_VariablesList.GetItemCount(), m_pVariableList[i].lpszVariableType);
		m_VariablesList.SetItemText(item, 1, m_pVariableList[i].lpszVariableName);
		m_VariablesList.SetItemText(item, 2, m_pVariableList[i].lpszVariableComment);
		switch (m_pVariableList[i].variableAccessLevel)
		{
			case AL_PUBLIC:
			{
				m_VariablesList.SetItemText(item, 3, _T("public"));
			}
			break;
			case AL_PROTECTED:
			{
				m_VariablesList.SetItemText(item, 3, _T("protected"));
			}
			break;
			case AL_PRIVATE:
			{
				m_VariablesList.SetItemText(item, 3, _T("private"));
			}
			break;
		}
		if (m_pVariableList[i].bProperty)
			m_VariablesList.SetItemText(item, 4, m_pVariableList[i].lpszPropertyName);
		else
			m_VariablesList.SetItemText(item, 4, _T(""));
		if (m_pVariableList[i].bStatic)
			m_VariablesList.SetItemText(item, 5, _T("yes"));
		else
			m_VariablesList.SetItemText(item, 5, _T("no"));
	}

	// Init members
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClassOptions2::OnButtonAdd() 
{
	UpdateData(TRUE);

	// Check for valid variable
	if ((m_Type != _T("")) && (m_Name != _T("")))
	{
		if ((!m_Property) || ((m_Property) && (m_PropertyName != _T(""))))
		{
			// Add new variable
			int item = m_VariablesList.InsertItem(m_VariablesList.GetItemCount(), m_Type);
			m_VariablesList.SetItemText(item, 1, m_Name);
			m_VariablesList.SetItemText(item, 2, m_Comment);
			CString strAccessLevel;
			switch (m_Access)
			{
				case 0:
				{
					strAccessLevel = _T("public");
				}
				break;

				case 1:
				{
					strAccessLevel = _T("protected");
				}
				break;

				case 2:
				{
					strAccessLevel = _T("private");
				}
				break;
			}
			m_VariablesList.SetItemText(item, 3, strAccessLevel);
			if (m_Property)
				m_VariablesList.SetItemText(item, 4, m_PropertyName);
			else
				m_VariablesList.SetItemText(item, 4,  _T(""));
			if (m_Static)
				m_VariablesList.SetItemText(item, 5, _T("yes"));
			else
				m_VariablesList.SetItemText(item, 5, _T("no"));

			// Update variable list
			UpdateVariables();
		}
		else
			AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
	}
	else
		AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
}

void CClassOptions2::OnButtonRemove() 
{
	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Remove variable
		m_VariablesList.DeleteItem(item);

		// Update variable list
		UpdateVariables();
	}
}

void CClassOptions2::OnButtonUpdate() 
{
	UpdateData(TRUE);

	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Check for valid variable
		if ((m_Type != _T("")) && (m_Name != _T("")))
		{
			if ((!m_Property) || ((m_Property) && (m_PropertyName != _T(""))))
			{
				// Update variable
				m_VariablesList.SetItemText(item, 0, m_Type);
				m_VariablesList.SetItemText(item, 1, m_Name);
				m_VariablesList.SetItemText(item, 2, m_Comment);
				CString strAccessLevel;
				switch (m_Access)
				{
					case 0:
					{
						strAccessLevel = _T("public");
					}
					break;

					case 1:
					{
						strAccessLevel = _T("protected");
					}
					break;

					case 2:
					{
						strAccessLevel = _T("private");
					}
					break;
				}
				m_VariablesList.SetItemText(item, 3, strAccessLevel);
				if (m_Property)
					m_VariablesList.SetItemText(item, 4, m_PropertyName);
				else
					m_VariablesList.SetItemText(item, 4,  _T(""));
				if (m_Static)
					m_VariablesList.SetItemText(item, 5, _T("yes"));
				else
					m_VariablesList.SetItemText(item, 5, _T("no"));

				// Update variable list
				UpdateVariables();
			}
			else
				AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
		}
		else
			AfxMessageBox(_T("Some field values are not valid..."), MB_OK);
	}
}

void CClassOptions2::OnClickListVariables(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Check for selected variable
	POSITION pos = m_VariablesList.GetFirstSelectedItemPosition();
	int item = m_VariablesList.GetNextSelectedItem(pos);
	if (item != -1)
	{
		// Get variable
		m_Type = m_VariablesList.GetItemText(item, 0);
		m_Name = m_VariablesList.GetItemText(item, 1);
		m_Comment = m_VariablesList.GetItemText(item, 2);
		CString strAccessLevel = m_VariablesList.GetItemText(item, 3);
		if (strAccessLevel == _T("public"))
		{
			m_Access = 0;
		}
		else if (strAccessLevel == _T("protected"))
		{
			m_Access = 1;
		}
		else
		{
			m_Access = 2;
		}
		CString strProperty = m_VariablesList.GetItemText(item, 4);
		if (strProperty != _T(""))
		{
			m_Property = TRUE;
			m_PropertyName = strProperty;

			// Enable property name field
			GetDlgItem(IDC_EDIT_PROPERTY_NAME)->EnableWindow(TRUE);
		}
		else
		{
			m_Property = FALSE;
			m_PropertyName = _T("");

			// Disable property name field
			GetDlgItem(IDC_EDIT_PROPERTY_NAME)->EnableWindow(FALSE);
		}
		CString strStatic = m_VariablesList.GetItemText(item, 5);
		if (strStatic == _T("yes"))
			m_Static = TRUE;
		else
			m_Static = FALSE;
	}

	UpdateData(FALSE);
	
	*pResult = 0;
}

void CClassOptions2::OnCheckProperty() 
{
	UpdateData(TRUE);

	// Check for property value
	if (m_Property)
	{
		// Enable property name field
		GetDlgItem(IDC_EDIT_PROPERTY_NAME)->EnableWindow(TRUE);
	}
	else
	{
		// Disable property name field
		GetDlgItem(IDC_EDIT_PROPERTY_NAME)->EnableWindow(FALSE);
	}
}

void CClassOptions2::UpdateVariables()
{
	// Resize variable list
	m_iVariableNumber = m_VariablesList.GetItemCount();
	m_pVariableList = (VARIABLE_TYPE*)realloc(m_pVariableList, m_iVariableNumber*sizeof(VARIABLE_TYPE));

	// Update variable list
	CString strAccessLevel, strProperty, strStatic;
	for (int i=0; i<m_VariablesList.GetItemCount(); i++)
	{
		// Update variable
		_tcscpy(m_pVariableList[i].lpszVariableType, m_VariablesList.GetItemText(i, 0));
		_tcscpy(m_pVariableList[i].lpszVariableName, m_VariablesList.GetItemText(i, 1));
		_tcscpy(m_pVariableList[i].lpszVariableComment, m_VariablesList.GetItemText(i, 2));
		strAccessLevel = m_VariablesList.GetItemText(i, 3);
		if (strAccessLevel == _T("public"))
		{
			m_pVariableList[i].variableAccessLevel = AL_PUBLIC;
		}
		else if (strAccessLevel == _T("protected"))
		{
			m_pVariableList[i].variableAccessLevel = AL_PROTECTED;
		}
		else
		{
			m_pVariableList[i].variableAccessLevel = AL_PRIVATE;
		}
		strProperty = m_VariablesList.GetItemText(i, 4);
		if (strProperty != _T(""))
		{
			m_pVariableList[i].bProperty = TRUE;
			_tcscpy(m_pVariableList[i].lpszPropertyName, strProperty);
		}
		else
		{
			m_pVariableList[i].bProperty = FALSE;
			_tcscpy(m_pVariableList[i].lpszPropertyName, _T(""));
		}
		strStatic = m_VariablesList.GetItemText(i, 5);
		if (strStatic == _T("yes"))
			m_pVariableList[i].bStatic = TRUE;
		else
			m_pVariableList[i].bStatic = FALSE;
	}
}
