// VCBClass.h: interface for the CVCBClass class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(VCBCLASS_H)
#define VCBCLASS_H

#include "VCBObject.h"


class CVCBClass : public CVCBObject  
{
public:
	CVCBClass(RECT rect);
	virtual ~CVCBClass();

public:
	// CVCBClass class interface
	void DrawVCBObject(HDC hDC);
	void SelectVCBObject(POINT pt);
	RECT GetVCBObjectRect();
	void MoveObject(int offsetX, int offsetY);
	void GenerateOutputFile();
	void GenerateHeaderFile();
	void GenerateImplementationFile();
	_TCHAR* GetVCBClassName();
	void SetVCBClassName(_TCHAR* lpszClassName);
	_TCHAR* GetVCBClassHeaderFile();
	void SetVCBClassHeaderFile(_TCHAR* lpszClassHeaderFile);
	_TCHAR* GetVCBClassImplementationFile();
	void SetVCBClassImplementationFile(_TCHAR* lpszClassImplementationFile);
	_TCHAR* GetVCBClassAuthor();
	void SetVCBClassAuthor(_TCHAR* lpszAuthor);
	_TCHAR* GetVCBClassDescription();
	void SetVCBClassDescription(_TCHAR* lpszDescription);
	int GetVCBClassVariableNumber();
	void SetVCBClassVariableNumber(int number);
	VARIABLE_TYPE* GetVCBClassVariables();
	void SetVCBClassVariables(VARIABLE_TYPE* pVariableList);
	int GetVCBClassMethodNumber();
	void SetVCBClassMethodNumber(int number);
	METHOD_TYPE* GetVCBClassMethods();
	void SetVCBClassMethods(METHOD_TYPE* pMethodList);
	int GetVCBClassParentNumber();
	void SetVCBClassParentNumber(int number);
	PARENT_NODE* GetVCBClassParents();
	void SetVCBClassParents(PARENT_NODE* pParentList);
	BOOL GetVCBClassMFCHeaders();
	void SetVCBClassMFCHeaders(BOOL bMFCHeaders);
	BOOL GetVCBClassComments();
	void SetVCBClassComments(BOOL bComments);
	void SaveObject(CArchive& ar);

private:
	// CVCBClass private methods
	void DrawShadow();
	void DrawBackground();
	void UpdateTransparency(HDC hDC);

private:
	// CVCBClass class members
	RECT m_rcObjectRect;
	HFONT m_hClassNameFont;
	HFONT m_hAttributesFont;
	HFONT m_hMethodsFont;
	_TCHAR m_lpszClassName[256];
	_TCHAR m_lpszClassHeaderFile[1024];
	_TCHAR m_lpszClassImplementationFile[1024];
	_TCHAR m_lpszAuthor[256];
	_TCHAR m_lpszDescription[256];
	VARIABLE_TYPE* m_pVariableList;
	int m_iVariableNumber;
	METHOD_TYPE* m_pMethodList;
	int m_iMethodNumber;
	PARENT_NODE* m_pParentList;
	int m_iParentNumber;
	BOOL m_bMFCHeaders;
	BOOL m_bComments;

};

#endif // !defined(VCBCLASS_H)
