// VCBObjectManager.h: interface for the CVCBObjectManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(VCBOBJECTMANAGER_H)
#define VCBOBJECTMANAGER_H

#include "VCBObject.h"
#include "VCBClass.h"
#include "VCBStruct.h"


typedef struct _VCBOBJ_LIST
{
	CVCBObject* pVCBObject;
	_VCBOBJ_LIST* pNext;

} VCBOBJ_LIST;



class CVCBObjectManager  
{
public:
	CVCBObjectManager();
	virtual ~CVCBObjectManager();

public:
	// CVCBObjectManager class interface
	void ClearVBCObjectList();
	void AddVCBObject(CVCBObject* pVCBObject);
	void RemoveVCBObject(CVCBObject* pVCBObject);
	int GetVCBObjectNumber();
	CVCBObject* GetCurrentVCBObject();
	void SetCurrentVCBObject(DWORD id);
	CVCBObject* GetVCBObject(int index);
	void SelectVCBObject(POINT pt);
	void DrawVCBObjects(HDC hDC);
	void GenerateOutputFiles();
	DWORD GetLastObjectID();
	void SaveToArchive(CArchive& ar);
	void LoadFromArchive(CArchive& ar);

private:
	// CVCBObjectManager class members
	VCBOBJ_LIST* m_pVCBObjectList;
	int m_iVCBObjectNumber;
	CVCBObject* m_pCurrentObject;
	DWORD m_dwVCBObjectID;

};

#endif // !defined(VCBOBJECTMANAGER_H)
